package
{
	import org.flixel.*;
	
	public class RealTitleState extends FlxState
	{
		[Embed(source = "data/title.png")] public static var ImgTitle:Class;		
		
		private var t:Number;
		override public function create():void
		{			
			super.create();
			stage.quality="low";

			bgColor=0xff000000;
				
			var bg:FlxSprite = new FlxSprite(0,0,ImgTitle);
			this.add(bg);
			
			flashtext = new FlxText(0,90,FlxG.width,"Press Space to Start");
			flashtext.color=0xffc03d3d;
			flashtext.alignment="center";
			flashtext.visible=false;
			this.add(flashtext);
			
			for (var i:int=1;i<5;i++)
			{
				var s:FlxSprite = new FlxSprite(43+10*(i-1),25);
				s.loadGraphic(Robot.ImgRobot,true,false,7,9);
				s.addAnimation("play",[(2*i)%5,(3*i)%5,(7*i)%5,(11*i)%5,(13*i)%5,(17*i)%5],2,true);
				s.play("play");
				this.add(s);
			}
			t=0;
			FlxG.playMusic(TitleState.SndMusic,0.4);
		}
		private var flashtext:FlxText;
		private var spacepressed:Boolean=false;
		
		override public function update():void
		{
			t+=FlxG.elapsed;
			if (!spacepressed)
			{
				flashtext.visible = t%1>0.5;
			}
			else
			{
				flashtext.visible=true;
			}
			
			if (FlxG.keys.justPressed("SPACE") && !spacepressed)
			{
				spacepressed=true;
				FlxG.fade.start(0xff000000,1,onFaded,true);
				FlxG.play(TitleState.SndPowerup);
				flashtext.flicker(1);
			}
			
			super.update();
		}
		
		private function onFaded():void
		{
			FlxG.state = new TitleState();
		}
	}
}