package
{
	import flash.display.Sprite;
	
	import org.flixel.*;
	
	public class Robot extends Charger
	{
		[Embed(source = "data/robotsmall.png")] public static var ImgRobot:Class;
		[Embed(source = "data/jump.mp3")] public static var SndJump:Class;
		
		private var _jumpPower:int;
		private var _up:Boolean;
		private var _down:Boolean;
		
		private var halo:Sprite;
		public var theta:Number;
			
		public var controlled:Boolean;
		
		public var chargetox:int;
		public var chargetoy:int;
		
		public function Robot(X:Number=0, Y:Number=0)
		{
			super(X, Y);
			this.solid=true;
			loadGraphic(ImgRobot,true,true,7,9);
			
			addAnimation("idle",[0,1],2,true);
			addAnimation("idle_up",[0,1],2,true);
			addAnimation("run",[0,2],8,true);
			addAnimation("run_up",[0,2],8,true);
			addAnimation("jump",[3],5,true);
			addAnimation("jump_up",[4],5,true);
			play("idle");
			beaconx=2.5;
			beacony=2;
			controlled=false;
			
			theta=Math.random()*(2*Math.PI);
			
			this.offset.x=1;
			this.width=5;
			this.height=9;
			
			var runSpeed:uint = 80;
			drag.x = runSpeed*8;
			acceleration.y = 420;
			_jumpPower = 170;
			maxVelocity.x = runSpeed;
			maxVelocity.y = _jumpPower;
			
			
			halo = new Sprite;
			halo.graphics.beginFill(0xFF0080, 0.5);
			halo.graphics.drawCircle(40, 40, 80);
			halo.graphics.endFill();
					
			canjump=false;
			// Doesn't matter the order, addChild will ALWAYS appear over the top of add()
		}
		
		public var rotamount:Number=1.0;
		public var accel:Number=3.0;
		public var rotspeed:Number;
		public var canjump:Boolean;
		override public function update():void
		{
			if (onFloor)
			{
				canjump=true;
			}
			acceleration.x = 0;
			if (controlled)
			{
				//MOVEMENT
				if(FlxG.keys.LEFT)
				{
					facing = LEFT;
					acceleration.x -= drag.x;
				}
				else if(FlxG.keys.RIGHT)
				{
					facing = RIGHT;
					acceleration.x += drag.x;
				}
				if( /*(FlxG.keys.justPressed("C") && !velocity.y) ||*/ ( (FlxG.keys.justPressed("C")||FlxG.keys.justPressed("UP")) && canjump))
				{
					canjump=false;
					FlxG.play(SndJump);
					velocity.y = -_jumpPower;
					//FlxG.play(SndJump);
				}
				
				if ( FlxG.keys.X)
				{
					var dtheta:Number = 0;
					/*if (charging)
					{
						theta = (theta+FlxG.elapsed*rotspeed/4.0) % (2*Math.PI);
					}
					else*/
					{
						dtheta = FlxG.elapsed*rotspeed;
					}
					
					if (charging)
					{
						dtheta=Math.max(FlxG.elapsed*rotamount/4,rotspeed*FlxG.elapsed/4);
					}
					
					theta = (theta-dtheta) % (2*Math.PI);
					
					if (isNaN(theta))
					{
						theta=0;
					}
				}
				if (FlxG.keys.V)
				{
					dtheta=0;
					/*if (charging)
					{
						theta = (theta-FlxG.elapsed*rotspeed/4.0) % (2*Math.PI);
					}
					else*/
					{
						dtheta = -FlxG.elapsed*rotspeed;
					}
					
					if (charging)
					{
						dtheta=Math.min(-FlxG.elapsed*rotspeed/4,-rotspeed*FlxG.elapsed/4);
					}
					
					theta = (theta-dtheta) % (2*Math.PI);
					
					if (isNaN(theta))
					{
						theta=0;
					}
				}
				
				if (!FlxG.keys.X && !FlxG.keys.V)
				{
					rotspeed=0;
				}
				else
				{
					rotspeed = Math.min(Math.min(rotamount*2,rotspeed+FlxG.elapsed*accel),3*rotamount);
				}
			}
					
			//ANIMATION
			if(velocity.y != 0)
			{
				if(_up) play("jump_up");
				else if(_down) play("jump_down");
				else play("jump");
			}
			else if(velocity.x == 0)
			{
				if(_up) play("idle_up");
				else play("idle");
			}
			else
			{
				if(_up) play("run_up");
				else play("run");
			}
		
						
			//UPDATE POSITION AND ANIMATION
			super.update();			
		}
	}
}