package
{	
	import Level.*;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	import flash.utils.Timer;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class TitleState extends FlxState
	{
		[Embed(source = "data/splosion.png")] public static var ImgSplosion:Class;
		[Embed(source = "data/checkpoint.png")] public static var ImgCheckpoint:Class;		
		[Embed(source = "data/selector.png")] public static var ImgSelector:Class;
		
		[Embed(source = "data/explode.mp3")] public static var SndExplode:Class;
		[Embed(source = "data/powerup.mp3")] public static var SndPowerup:Class;
		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/blip.mp3")] public static var SndBlip:Class;
		
		//		[Embed(source = "data/levels/level1.txt", mimeType = "application/octet-stream")] private var TxtLevel1:Class;
		
		
		private var level:BaseLevel;
		
		private var blocks:FlxGroup;
		private var robots:FlxGroup;
		private var bases:FlxGroup;
		
		private var chargers:Vector.<Charger>;
		
		public var radius:Number = 75;
		
		public var halos:FlxGroup;
		public var selected:int;
		public var activerobot:Robot;
		
		public var splosion:FlxEmitter;
		public var checkemitter:FlxEmitter;
		
		public var selector:FlxSprite;
		
		public var tilemap:FlxTilemap;
		
		private var checkpoint:int;
		
		private var triggertext:FlxText;
		private var triggertimer:Number;
		
		private function OnAddRobot(r:Robot):void
		{
			robots.add(r);
			chargers.push(r);
			var halo:Halo = new Halo(radius,r);
			halos.add(halo);	
			
			if (robots.members.length>1)
			{
				var ftext:FlickerText = new FlickerText(r.x+r.beaconx,r.y-15,100,"+1 robot");
				this.add(ftext);
				ftext.flicker(ftext.life);
			}
			if (robots.members.length==2)
			{
				triggerMessage("Press SPACE to switch between robots");	
			}
		}
		
		private function triggerMessage(s:String):void
		{
			triggertext.scrollFactor= new FlxPoint(0,0);
			triggertext.text=s;
			triggertext.visible=true;
			triggertimer=5;
		}
		
		private function onSpriteAddedCallback(sprite:*, group:FlxGroup,layer:BaseLevel,properties:Array):void
		{
			var i:int;
			
			if (sprite is TriggerBlock)
			{
				var block:TriggerBlock = sprite as TriggerBlock;
				for (i=0;i<properties.length;i++)
				{
					var o:Object = properties[i];					
					if (o.name=="blockid")
					{
						if (o.value>=0)
						{
							block.triggerid=o.value;
						}
					}
				}
				blocks.add(sprite);
			}
			if (sprite is Robot)
			{
				OnAddRobot(sprite as Robot);
				//				FlxG.follow(sprite,2.5);				
			}
			if (sprite is Base)
			{
				bases.add(sprite);
				var halo:Halo = new Halo(radius,sprite as Base);
				halos.add(halo);	
				
				var b:Base = sprite as Base;
				for (i=0;i<properties.length;i++)
				{
					var ob1:Object = properties[i];
					if (ob1.name=="Init" && ob1.value==true)
					{
						b.found = true;
						b.charging=true;
						b.triggered=true;
						checkpoint = bases.members.length-1;
						(bases.members[checkpoint] as FlxSprite).play("checkpoint");						
					}
					if (ob1.name=="triggerid")
					{
						if (ob1.value>=0)
						{
							b.triggerid=ob1.value;
						}
					}
					if (ob1.name=="AddRobot" && ob1.value==true)
					{
						b.addOnActivate=true;
					}
				}
			}
			if (sprite is FlxTilemap)
			{
				for (i=0;i<properties.length;i++)
				{
					var ob:Object = properties[i];
					if (ob.name=="mainlayer" && ob.value==true)
					{
						tilemap = sprite as FlxTilemap;
					}
				}
			}
		}
		
		public function controlRobot(n:int):void
		{
			for (var i:int=0;i<robots.members.length;i++)
			{
				var r:Robot = robots.members[i] as Robot;
				if (i==n)
				{
					r.controlled = true;
					activerobot=r;
				}
				else
				{
					r.controlled = false;
				}
			}
			FlxG.followTarget = robots.members[n];			
		}
		
		private var triggeredtwo:Boolean;
		private var mytime:Number;
		override public function create() : void
		{
			super.create();
			triggeredtwo=false;
			mytime=0;
			checkpoint=-1;
			chargers = new Vector.<Charger>();
			
			selected=0;
			//players = new Vector.<Robot>();
			//			level
			halos = new FlxGroup();
			robots = new FlxGroup();
			bases = new FlxGroup();
			blocks = new FlxGroup();
			bgColor=0xff000000;
			level = new Level_Group1(true,onSpriteAddedCallback);
			
			
			splosion = new FlxEmitter(0,0);
			splosion.setRotation();
			splosion.acceleration = new FlxPoint(0,0);				
			splosion.createSprites(ImgSplosion,60,0,true,1);
			this.add(splosion);
			
			checkemitter = new FlxEmitter(0,0);
			checkemitter.setRotation();
			checkemitter.acceleration = new FlxPoint(0,0);				
			checkemitter.createSprites(ImgCheckpoint,60,0,true,1);
			this.add(checkemitter);
			
			for(var i:int=0;i<bases.members.length;i++)
			{
				chargers.push(bases.members[i] as Charger);
			}
			
			controlRobot(0);
			this.add(halos);
			
			selector = new FlxSprite(0,0,ImgSelector);
			add(selector);
			FlxG.followAdjust(0.5, 0.2);
			
			//			FlxG.followAdjust(0,0);
			//			FlxG.followLerp=0;
			FlxG.followBounds(tilemap.left + 1, tilemap.top + 1, tilemap.right - 1, tilemap.bottom - 1);
			FlxU.setWorldBounds(tilemap.left, tilemap.top, tilemap.width, tilemap.height);
			
			triggertext = new FlxText(0,5,FlxG.width,"");
			triggertext.color=0xff886600;
			triggertext.alignment="center";
			triggertext.visible=false;
			this.add(triggertext);
			
			triggerMessage("X and V to rotate beam\nC to jump.");	
			
			FlxG.flash.start(0xff000000,0.1);
		}
		
		private var players:Vector.<Robot>;
		
		public static function segmentDistToPoint(segA:Point, segB:Point, p:Point):Number
		{
			var p2:Point = new Point(segB.x - segA.x, segB.y - segA.y);
			var something:Number = p2.x*p2.x + p2.y*p2.y;
			var u:Number = ((p.x - segA.x) * p2.x + (p.y - segA.y) * p2.y) / something;
			
			if (u > 1)
				u = 1;
			else if (u < 0)
				u = 0;
			
			var x:Number = segA.x + u * p2.x;
			var y:Number = segA.y + u * p2.y;
			
			var dx:Number = x - p.x;
			var dy:Number = y - p.y;
			
			var dist:Number = Math.sqrt(dx*dx + dy*dy);
			
			return dist;
		}
		
		private function respawn(r:Robot):void
		{
			splosion.at(r);
			splosion.start(true,2,15);
			
			
			var b:Base = bases.members[checkpoint] as Base;
			for (var i:int=0;i<robots.members.length;i++)
			{
				var rp:Robot = robots.members[i] as Robot;
				rp.x=b.x+b.beaconx +(Math.random()*11-5);
				rp.y=b.y+b.beacony;
				rp.velocity.x=0;
				rp.velocity.y=0;
			}			
			
			for (i=0;i<bases.members.length;i++)
			{
				b = bases.members[i] as Base;
				if (b.charging && b.triggered==false)
				{
					b.charging=false;
					b.found=false;
				}
			}
		}
		
		private function spawnNewRobot(ob:Charger):void
		{
			var r:Robot = new Robot(ob.x,ob.y);	
			
			r.x=ob.x+ob.beaconx-r.beaconx;
			r.y=ob.y+ob.beacony-r.beacony;
			this.level.masterLayer.add(r);
			OnAddRobot(r);
		}
		
		private function dist(a:FlxObject, b:FlxObject):Number
		{
			var dx:Number = a.x-b.x;
			var dy:Number = a.y-b.y;
			return Math.sqrt(dx*dx+dy*dy);
		}
		
		private function distsq(a:FlxObject, b:FlxObject):Number
		{
			var dx:Number = a.x-b.x;
			var dy:Number = a.y-b.y;
			return dx*dx+dy*dy;
		}
		
		private var fudge:int=5;
		override public function update() : void
		{			
			if (this.robots.members.length>1 && !this.triggeredtwo)
			{
				mytime+=FlxG.elapsed;
				if (mytime>15)
				{
					triggeredtwo=true;
//					triggerMessage("Bring all of your robots to a checkpoint to activate it.");
				}
			}
			if (triggertimer>0)
			{
				triggertimer-=FlxG.elapsed;
				if (triggertimer<0)
				{
					triggertext.visible=false;
				}				
			}
			tilemap.collide(robots);	
			blocks.collide(robots);
			tilemap.collide(splosion);
			
			if (FlxG.keys.justPressed("SPACE"))
			{
				selected = (selected+1)%robots.members.length;
				controlRobot(selected);
			}
			//if (FlxG.keys.justPressed("R"))
			//{
			//	spawnNewRobot(this.bases.members[0] as Charger);
			//}
			var closestcheckpointindex:int = -1;
			var closestcheckpointdist:Number = Number.MAX_VALUE;
			
			for (i=0;i<bases.members.length;i++)
			{				
				var b:Base = bases.members[i] as Base;
				if (b.found==false)
					continue;
				
				var there:Boolean=true;
				for (j=0;j<robots.members.length;j++)
				{
					var r:Robot = robots.members[j] as Robot;
					
					if (distsq(r,b)>=20*20)
					{
						there=false;
						break;
					}
				}
				if (there)
				{
					var mydist:Number = distsq(activerobot,b);
					if (mydist<closestcheckpointdist)
					{
						closestcheckpointdist = mydist;
						closestcheckpointindex = i;
					}					
				}			
			}
			
			if (closestcheckpointindex>=0 && closestcheckpointindex!=checkpoint)
			{
				checkpoint=closestcheckpointindex;
				
				checkemitter.at(bases.members[closestcheckpointindex]);
				checkemitter.start(true,2,15);
				
				for (i=0;i<bases.members.length;i++)
				{
					(bases.members[i] as FlxSprite).play("default");
				}
				
				var base:Base = bases.members[checkpoint] as Base;
				
				base.triggered=true;
				
				base.play("checkpoint");
				
				if (base.triggerid>=0)
				{
					for (var k:int=blocks.members.length-1;k>=0;k--)
					{
						var block:TriggerBlock = blocks.members[k] as TriggerBlock;
						if (block.triggerid==base.triggerid)
						{
							block.kill();
						}
					}
					if (base.triggerid==2 && !triggeredtwo)
					{		
						triggeredtwo=true;
//						triggerMessage("Bring all of your robots to a checkpoint to activate it.");
					}
					if (base.triggerid==9)
					{
						FlxG.fade.start(0xff000000,1,OnFaded);
					}
				}
				
				FlxG.play(SndPowerup);
				//				FlxG.quake.start(0.01,0.25);
				if (base.addOnActivate && !base.robotspawned)
				{
					base.robotspawned=true;
					spawnNewRobot(base);
				}	
			}
			
			
			//have to do this to stop loops I think
			for (i=0;i<robots.members.length;i++)
			{
				//				(robots.members[i] as Robot).charging=false;
			}
			
			for (var i:int=0;i<robots.members.length;i++)
			{			
				//connect beams
				r = robots.members[i] as Robot;
				var wascharging:Boolean=r.charging;
				r.charging=false;
				var powered:Boolean=false;
				for (var j:int=0;j<chargers.length;j++)
				{						
					var c:Charger = chargers[j];
					
					//power on/off
					if (c.charging)
					{
						var dxt:int = r.x+r.beaconx-(c.x+c.beaconx);
						var dyt:int = r.y+c.beacony-(c.y-c.beacony);
						if (dxt*dxt+dyt*dyt < (radius+fudge)*(radius+fudge))
						{
							powered=true;																			
						}
					}
					
					//connection
					if (r==c)
						continue;
					if (c.charging==false && c.latent==false)
					{
						continue;
					}
					
					var p1x:Number = r.x+r.beaconx;
					var p1y:Number = r.y+r.beacony;
					var p2x:Number = p1x+radius*Math.cos(r.theta);
					var p2y:Number = p1y+radius*Math.sin(r.theta);
					
					var tx:Number = c.x+c.beaconx;
					var ty:Number = c.y+c.beacony;
					
					
					
					var dp:Point = new Point(p2x - p1x, p2y - p1y);
					var something:Number = dp.x*dp.x + dp.y*dp.y;
					var u:Number = ((tx - p1x) * dp.x + (ty - p1y) * dp.y) / something;
					
					if (u > 1)
						u = 1;
					else if (u < 0)
						u = 0;
					
					var mx:Number = p1x + u * dp.x;
					var my:Number = p1y + u * dp.y;
					
					var dx:Number = mx - tx;
					var dy:Number = my - ty;
					
					var dist:Number = Math.sqrt(dx*dx + dy*dy);
					
					if (dist<2)
					{						
						r.charging=true;
						r.chargetox=mx;
						r.chargetoy=my;
						
						if (r.charging!=wascharging)
						{					
							FlxG.play(SndBlip,0.4);
						}
						
						if (c is Base)
						{
							b = c as Base;
							if (b.found==false)
							{
								if (b.triggerid==2 && !triggeredtwo)
								{
									triggeredtwo=true;
									triggerMessage("Bring all of your robots to a checkpoint to activate it.");
								}
								b.found=true;
								b.charging=true;																							
							}
						}
					}
				}
				if (!powered)
				{
					respawn(r);					
					FlxG.play(SndExplode);
				}
				
			}
			super.update();	
			
			selector.x=activerobot.x-3;
			selector.y=activerobot.y-2;
			
		}	
		
		private function OnFaded():void
		{
			FlxG.state = new EndState();
		}
	}	
}